int MAXX=297;
int MAXY=210;

final color PINK  = color(255,175,150);
final color GOLD  = color(255,200,100);
final color SKY   = color(150,150,255);

class Kernel {
  int x;
  int y;
  color clr;  
  void dna() { 
       x = int(random(MAXX));
       y = int(random(MAXY));
       float c=random(3);
       if (c < 1) 
          clr = PINK;
          else if (c < 2)
               clr = GOLD;
               else clr = SKY;
  }
}

class Cell extends Kernel {
  int xMin,xMax;
  int yMin,yMax;
  Cell(){
    dna();
    xMin=x-1;
    xMax=x+1;
    yMin=y-1;
    yMax=y+1;   
  }
  boolean contains(int xOther, int yOther){
       return (  (xOther >= xMin && xOther <= xMax)
              && (yOther >= yMin && yOther <= yMax)
              )   ; 
  }
  boolean ok() {
       return(   xMin>=0 && xMax<MAXX 
              && yMin>=0 && yMax<MAXY 
              && xMax-xMin < MAXX/4 
              && yMax-yMin < MAXY/4
             )   ;
  }
  boolean ok(Cell other){
       return (  !contains(other.xMin,other.yMin)
              && !contains(other.xMin,other.yMax)
              && !contains(other.xMax,other.yMin)
              && !contains(other.xMax,other.yMax) 
              )  ;
  }
  boolean okok(Cell other){
       return (this.ok(other) && other.ok(this));
  }
  boolean ok(Cell[] others){
       boolean test = ok();
       for (int i=0; i<others.length; i++)
           if (others[i]!=this)
               if (!okok(others[i])) 
                  test = false;
       return test;
  }
  void grw(Cell[] others){ 
       int delta = 7 + int(random(3));
       xMin = xMin-delta;
       xMax = xMax+delta;
       yMin = yMin-delta;
       yMax = yMax+delta;
       if (!ok(others)) { 
           xMin = xMin+delta; 
           xMax = xMax-delta; 
           yMin = yMin+delta; 
           yMax = yMax-delta; 
       } 
  }
  void drw(){
    fill(clr); 
    if (xMax-xMin > 10) {
        stroke(clr); 
        rect(xMin,yMin,xMax-xMin,yMax-yMin);
    }
  }
}

final int NRCELLS = 25;
Cell[] cells =new Cell[NRCELLS]; 

void setup(){
     size(MAXX,MAXY);
     background(250);
     for (int i=0; i<NRCELLS; i++) { 
          cells[i] = new Cell(); 
          cells[i].drw();
    } 
}

void draw(){
    delay(1000);
    for (int i=0; i<NRCELLS; i++) {
         cells[i].grw(cells);
         cells[i].drw(); 
    }
}
